program exercise7
  implicit none

  double precision :: a_deg, b_deg, a_rad, b_rad
  double precision :: pi

  double precision :: a_mat(1:2,1:2), b_mat(1:2,1:2), c_mat(1:2,1:2)
  complex(kind(0d0)) :: a_complex, b_complex, c_complex

  integer :: i,j,k

  print *, "enter a, b (deg)"  
  read(*,*) a_deg, b_deg       ! aとbを標準入力から読み込む

  pi = acos(-1.0d0)  ! piをcos^-1(-1)から計算。もちろんpi=3.141592...と近似値を代入してもよい。
   
  a_rad = a_deg * pi/180.0d0   ! 度からラジアンに変換
  b_rad = b_deg * pi/180.0d0   ! 度からラジアンに変換


  print *, "cos(a+b) = ", cos(a_rad+b_rad), "sin(a+b) = ", sin(a_rad+b_rad)  ! a+bのcosとsinを出力

  ! 角度a回転の回転行列a_matを作る
  a_mat(1,1) =  cos(a_rad) 
  a_mat(1,2) = -sin(a_rad)
  a_mat(2,1) =  sin(a_rad)
  a_mat(2,2) =  cos(a_rad)
  ! 角度b回転の回転行列b_matを作る
  b_mat(1,1) =  cos(b_rad)
  b_mat(1,2) = -sin(b_rad)
  b_mat(2,1) =  sin(b_rad)
  b_mat(2,2) =  cos(b_rad)

  ! a_matとb_matの行列の積をc_matに代入
  c_mat(1:2,1:2) = matmul(a_mat(1:2,1:2), b_mat(1:2,1:2))

  ! あるいはdoループを使って
  !do j = 1, 2
  !   do i = 1, 2
  !      c_mat(i,j) = 0.0d0  ! c_matに初期値ゼロを代入
  !   end do
  !end do
  !do j = 1, 2
  !   do i = 1, 2
  !      do k = 1, 2
  !         c_mat(i,j) = c_mat(i,j) + a_mat(i,k)*b_mat(k,j) ! a_mat*b_matをc_matに代入
  !      end do
  !   end do
  !end do
  ! としてもよい
  
  ! c_matでcosとsinに対応する要素を出力
  print *, " c(1,1)  = ", c_mat(1,1),  " c(2,1)  = ", c_mat(2,1)


  ! 倍精度複素数変数a_complexの実部と虚部にcos(a_rad)とsin(a_rad)を代入
  a_complex = dcmplx( cos(a_rad), sin(a_rad))
  ! 倍精度複素数変数b_complexの実部と虚部にcos(b_rad)とsin(b_rad)を代入
  b_complex = dcmplx( cos(b_rad), sin(b_rad))

  ! a_complexとb_complexの積をc_complexに代入
  c_complex = a_complex * b_complex

  ! c_complexの実部と虚部を出力
  print *, " re(c)   = ", dble(c_complex), " im(c)   = ", aimag(c_complex)
  
end program exercise7
